// mkcal.h		ver.0.01
//copyright 2008 Beer[Tsutsumi Hiroyuki]

#include	<Be.h>
#include	<be_apps/Tracker/Background.h>
#if	B_BEOS_VERSION>=0x0520
#include	<Locale.h>
typedef	const char	Char;
#else
#define	_T(str)	str
typedef	char		Char;
#endif

#include	"slider.h"


typedef struct{
		bool	f;
		BRect	r;
}s_sel;

typedef struct{
	font_family	fam;
	font_style	sty;
	BMenuItem	*my,*mm,*md;	//for font_menu(year,month,day)
}font;

class object
{
	public:
		object(object *src=NULL);
		
		BRect	r;
		uchar	type;
		int		when;
		uchar	bgtype;
		uint32	bgcolor;

		uchar	year_type;
		char	year_fontf[128];
		char	year_fonts[128];
		int		year_size;
		uint32	year_color;
		uchar	month_type;
		char	month_fontf[128];
		char	month_fonts[128];
		int		month_size;
		uint32	month_color;
//		uchar	week_str;
//		char	week_fontf[128];
//		char	week_fonts[128];
//		int		week_size;
		uchar	day_type;
		char	day_fontf[128];
		char	day_fonts[128];
		int		day_size;
		uint32	day_color;
		uint32	sun_color;
		uint32	sat_color;
		uint32	hol_color;
		uchar	today_deco;
		uint32	today_color;
		int		year_font;
		int		month_font;
		int		day_font;
};


class mkcalview:public BView
{
	public:
		mkcalview(BRect frame);
		~mkcalview();
		void	draw_cal();
		void	adj(int *year,int *month,int *day);
		int		what_day(int year,int month,int day,int *w,int *d,int *z);
		char*	ystr(int year,int type);
		void	load(entry_ref &eref);
		void	save(entry_ref &dir,char *name);
		void	clr_obj();
		void	load_config(entry_ref &eref);
		void	save_config(entry_ref &dir,const char *name);
		void	create_wallpaper();
		void	set_wallpaper(char *path);
//	private:
		BBitmap		*bm,*bimg;
};

class preview:public BView
{
	public:
		preview(BRect frame);
		~preview();
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	MouseDown(BPoint pt);
		void	MouseUp(BPoint pt);
		void	MouseMoved(BPoint pt, uint32 code, const BMessage *msg);
		void	MessageReceived(BMessage *msg);
		void	redraw(bool rf=true);
		void	drawframe();
		void	eraseframe();
		mkcalview	*mv;
	private:
		int			mf;			//-1..inner  1..lefttop  2..righttop  3..leftbottom  4..rightbottom
		BPoint		mpt;		//button_down_point
};

class prevwindow:public BWindow
{
	public:
		prevwindow(BRect frame);
		bool	QuitRequested();
		void	Zoom(BPoint rec_position,float rec_width,float rec_height);
		void	FrameResized(float width,float height);
		preview	*v;
		BScrollBar	*sbv,*sbh;
};

class configview:public BView
{
	public:
		configview(BRect frame);
		~configview();
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	MessageReceived(BMessage *msg);
		BPopUpMenu*	setupfontmenu(int mn);
		BPopUpMenu*	setupformatmenu();
		void	redraw(int no=-2);
	private:
		int		conf_no;
		BView			*v_base,*v_obj;

		BView			*rv_base_mode;
		BRadioButton	*rb_base_mode1,*rb_base_mode2,*rb_base_mode3,*rb_base_mode4;
		BButton			*bt_search;
		BTextControl	*tc_base_col,*tc_base_fn,*tc_bg_bounds,*tc_scrn_col;
		BCheckBox		*cb_auto,*cb_textback;
		rgbslider		*sl_base_col,*sl_scrn_col;
		
		BStringView		*sv_sel_no;
		BButton			*bt_back,*bt_next,*bt_add,*bt_del;
		BTextControl	*tc_bounds,*tc_bg_col,*tc_when,*tc_today_col;
		BTextControl	*tc_year_col,*tc_month_col,*tc_day_col,*tc_sun_col,*tc_sat_col,*tc_hol_col;
		BTextControl	*tc_year_size,*tc_month_size,*tc_day_size;
		BView			*rv_bg_type,*rv_cal_type,*rv_year_type,*rv_month_type,*rv_today_deco;
		BRadioButton	*rb_bg_type1,*rb_bg_type2,*rb_cal_type1,*rb_cal_type2,*rb_cal_type3;
		BRadioButton	*rb_year_type1,*rb_year_type2,*rb_year_type3;
		BRadioButton	*rb_month_type1,*rb_month_type2,*rb_month_type3,*rb_month_type4;
		BRadioButton	*rb_today_deco1,*rb_today_deco2,*rb_today_deco3;
		BMenuField		*mf_year,*mf_month,*mf_day,*mf_outfmt;
		slider			*sl_year_size,*sl_month_size,*sl_day_size;
		rgbslider		*sl_bg_col,*sl_today_col;
		rgbslider		*sl_year_col,*sl_month_col,*sl_day_col,*sl_sun_col,*sl_sat_col,*sl_hol_col;
};

class configwindow:public BWindow
{
	public:
		configwindow(BRect frame);
		bool	QuitRequested();
		void	setupmenus();
		configview	*v;
	private:
};

class mkcal:public BApplication
{
	public:
		mkcal(int argc,char **argv);
		~mkcal();
		void	AboutRequested();
		void	get_translator_for_output();
		void	get_fonts();
		mkcalview	*v;
		prevwindow	*pw;
		configwindow	*cw;
};

BFilePanel	*fp;
BRect	scrn;
s_sel	sel_old,sel_now;			//for drawframe only
int		sel_no;						//selected_item_no.			-1..none
BList	fontl;
int		dfn;						//default_font_no  ...  be_plain_font

int		base_mode;
uint32	base_color,scrn_color;
char	baseimgpath[256];
BRect	bg_bounds;
int		outfmt;
bool	autoset,textback;					//set wallpaper when output,erase_text_back
BList	obl;

int	now_y,now_m,now_d,now_w;

BTranslatorRoster	*tr;
int32				trc=0;
BList				xlt;

struct xlator{
	translator_id		id;
	uint32				type;
	char				name[251];
	char				mime[251];
	BMenuItem	*m;					//for font_menu
};

char const	month_name[][10]={
	"１","２","３","４","５","６",
	"７","８","９","１０","１１","１２",
	"一月","二月","三月","四月","五月","六月",
	"七月","八月","九月","十月","十一月","十二月",
	"睦月","如月","弥生","卯月","皐月","水無月",
	"文月","葉月","長月","神無月","霜月","師走",
	"january","february","march","april","may","june",
	"july","august","september","october","november","december",
};

char const	holyday_name[][19]={
	"元日",			// 1/1
	"成人の日",		// 1/w2mon
	"建国記念の日",	// 2/11
	"春分の日",		// 3/futei
	"昭和の日",		// 4/29
	"憲法記念日",		// 5/3
	"みどりの日",		// 5/4
	"こどもの日",		// 5/5
	"海の日",		// 7/w3mon
	"敬老の日",		// 9/w3mon
	"秋分の日",		// 9/futei
	"体育の日",		// 10/w2mon
	"文化の日",		// 11/3
	"勤労感謝の日",	// 11/23
	"天皇誕生日",		// 12/23
	"振替休日",
	"国民の休日"
};
